SystemOrganization addCategory: #SlotTests!

Trait named: #TOne
	uses: {}
	category: 'SlotTests'!

!TOne methodsFor: 'as yet unclassified' stamp: 'MartinDias 8/1/2012 00:06'!
one
	^ 1! !

Trait named: #TTwo
	uses: {}
	category: 'SlotTests'!

!TTwo methodsFor: 'as yet unclassified' stamp: 'MartinDias 8/1/2012 00:11'!
two
	^ 2! !

SharedPool subclass: #TestSharedPool
	instanceVariableNames: ''
	classVariableNames: 'One'
	poolDictionaries: ''
	category: 'SlotTests'!

!TestSharedPool class methodsFor: 'class initialization' stamp: 'MartinDias 8/7/2012 02:06'!
initialize
	One := 1! !

TestCase subclass: #SlotClassBuilderTest
	instanceVariableNames: 'aClass announcement announcementsCount instance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotTests'!

!SlotClassBuilderTest methodsFor: 'helpers' stamp: 'MartinDias 7/31/2012 01:45'!
aClassName
	^ #NewSlotTestObject! !

!SlotClassBuilderTest methodsFor: 'helpers' stamp: 'MartinDias 7/31/2012 01:48'!
anotherClassName
	^ #NewSlotTestObject2! !

!SlotClassBuilderTest methodsFor: 'helpers' stamp: 'GuillermoPolito 7/30/2012 23:22'!
assertOnlyOneAnnouncementOf: anAnnouncement within: aBlock
	SystemAnnouncer uniqueInstance weak on: anAnnouncement send: #countAnnouncements: to: self.
	aBlock value.
	self assert: announcementsCount <= 1! !

!SlotClassBuilderTest methodsFor: 'helpers' stamp: 'MartinDias 7/31/2012 01:47'!
buildClassWith: anUnaryBlock
	"I build a class for testing, providing basic default values, but eventually customized by the received unary block."

	^PharoClassInstaller make: [:builder|
		builder
			superclass: Object;
			name: self aClassName;
			layoutClass: PointerLayout;
			category: 'SlotTestTmp'.
		anUnaryBlock value: builder
		].! !

!SlotClassBuilderTest methodsFor: 'helpers' stamp: 'GuillermoPolito 7/30/2012 22:11'!
buildClassWithLayout: aClassLayout
	^self buildClassWithLayout: aClassLayout andSlots: {}! !

!SlotClassBuilderTest methodsFor: 'helpers' stamp: 'MartinDias 7/31/2012 01:39'!
buildClassWithLayout: aClassLayout andSlots: someSlots
	"
	I create a class using the Slot class builder given a class layout and a collection of slots.
	"

	^self buildClassWith: [:builder|
		builder
			layoutClass: aClassLayout;
			slots: someSlots
		].! !

!SlotClassBuilderTest methodsFor: 'helpers' stamp: 'GuillermoPolito 7/30/2012 23:11'!
countAnnouncements: anAnnouncement 
	announcementsCount := announcementsCount + 1! !

!SlotClassBuilderTest methodsFor: 'helpers' stamp: 'GuillermoPolito 7/30/2012 23:09'!
saveAnnouncement: anAnnouncement
	announcement := anAnnouncement! !

!SlotClassBuilderTest methodsFor: 'helpers' stamp: 'GuillermoPolito 7/30/2012 23:09'!
saveAnnouncementOnce: anAnnouncement
	announcement ifNotNil: [ ^self ].
	announcement := anAnnouncement! !

!SlotClassBuilderTest methodsFor: 'running' stamp: 'MartinDias 7/31/2012 01:47'!
setUp
	super setUp.
	announcementsCount := 0.! !

!SlotClassBuilderTest methodsFor: 'helpers' stamp: 'MartinDias 8/7/2012 00:32'!
should: superclassBlock extendWith: subclassBlock

	| superclass |
	superclass := self silentlyBuildClassWith: superclassBlock.

	self silentlyBuildClassWith: [ :builder | 
		builder 
			superclass: superclass;
			name: self anotherClassName;
			in: subclassBlock ]! !

!SlotClassBuilderTest methodsFor: 'helpers' stamp: 'MartinDias 8/7/2012 00:25'!
shouldnt: superclassBlock extendWith: subclassBlock

	| superclass |
	superclass := self silentlyBuildClassWith: superclassBlock.

	self should: [
		self silentlyBuildClassWith: [ :builder | 
			builder 
				superclass: superclass;
				name: self anotherClassName;
				in: subclassBlock ] ]
		raise: PrimitiveTypeConflict! !

!SlotClassBuilderTest methodsFor: 'helpers' stamp: 'MartinDias 7/31/2012 01:35'!
silentlyBuildClassWith: anUnaryBlock
	"
	I build a class for testing, providing basic default values, but eventually customized by the received unary block.
	I do it silently so I do not put side effects on the system
	"
	
	SystemAnnouncer uniqueInstance suspendAllWhile: [
		^self buildClassWith: anUnaryBlock
	]! !

!SlotClassBuilderTest methodsFor: 'helpers' stamp: 'GuillermoPolito 7/30/2012 22:50'!
silentlyBuildClassWithLayout: aClassLayout
	^self silentlyBuildClassWithLayout: aClassLayout andSlots: {}! !

!SlotClassBuilderTest methodsFor: 'helpers' stamp: 'GuillermoPolito 7/30/2012 22:52'!
silentlyBuildClassWithLayout: aClassLayout andSlots: someSlots
	"
	I create a class using the Slot class builder given a class layout and a collection of slots.
	I do it silently so I do not put side effects on the system
	"
	
	SystemAnnouncer uniqueInstance suspendAllWhile: [
		^self buildClassWithLayout: aClassLayout andSlots: someSlots.
	]! !

!SlotClassBuilderTest methodsFor: 'helpers' stamp: 'MartinDias 7/31/2012 00:41'!
silentlyCompile: sourceCode in: someClass
	"
	I compile a method in a class.
	I do it silently so I do not put side effects on the system
	"
	
	SystemAnnouncer uniqueInstance suspendAllWhile: [
		someClass compile: sourceCode classified: 'test'
	]! !

!SlotClassBuilderTest methodsFor: 'running' stamp: 'MartinDias 7/31/2012 01:50'!
tearDown
	"We remove the classes that could have been created during test run"
	super tearDown.
	SystemAnnouncer uniqueInstance suspendAllWhile: [
		{ self aClassName. self anotherClassName } do: [ :each | 
			Smalltalk at: each ifPresent: [ :class | class removeFromSystem ] ]
	].
	SystemAnnouncer uniqueInstance unsubscribe: self.! !

!SlotClassBuilderTest methodsFor: 'tests-class slots' stamp: 'MartinDias 8/6/2012 17:39'!
testAddClassSlotAndMigrate

	| classAdded classModified |
	classAdded := 
		self silentlyBuildClassWith: [ :builder | 
			builder classSlots: #(a) ].

	classAdded instVarNamed: #a put: $A.
	
	classModified := 
		self silentlyBuildClassWith: [ :builder | 
			builder classSlots: #(a b) ].
	
	self assert: (classModified instVarNamed: #a) equals: $A.
	self assert: (classModified instVarNamed: #b) isNil.! !

!SlotClassBuilderTest methodsFor: 'tests-shared pools' stamp: 'MartinDias 8/7/2012 02:17'!
testAddSharedPool

	self silentlyBuildClassWith: [ :builder | 
		builder sharedPools: '' ].

	aClass := self silentlyBuildClassWith: [ :builder | 
		builder sharedPools: 'TestSharedPool' ].
	
	self assert: (aClass sharedPools includes: TestSharedPool).
! !

!SlotClassBuilderTest methodsFor: 'tests-shared variables' stamp: 'MartinDias 8/7/2012 02:37'!
testAddSharedVariable

	self silentlyBuildClassWith: [ :builder | 
		builder sharedVariables: '' ].

	aClass := self silentlyBuildClassWith: [ :builder | 
		builder sharedVariables: 'Var' ].
	
	self assert: aClass classVarNames equals: #(Var).
! !

!SlotClassBuilderTest methodsFor: 'tests-migrations' stamp: 'MartinDias 8/6/2012 16:09'!
testAddSlotAndMigrate
	"We create a class without slots and create an instance; then we add a slot and check the instance can hold a value."
	| classAdded classModified |
	classAdded := self silentlyBuildClassWithLayout: PointerLayout.
	
	instance := classAdded new.
	
	"now we extend it with slots.  The class definition should've changed"
	classModified := self silentlyBuildClassWithLayout: PointerLayout andSlots: { #aSlot => Slot }.
	
	"it should have an instance variable"
	instance instVarAt: 1 put: 125.! !

!SlotClassBuilderTest methodsFor: 'tests-valid extensions' stamp: 'MartinDias 8/7/2012 00:35'!
testByteCanExtendByte

	self should: [ :builder | 
			builder layoutClass: ByteLayout ]
		extendWith: [ :builder | 
			builder layoutClass: ByteLayout ]! !

!SlotClassBuilderTest methodsFor: 'tests-invalid extensions' stamp: 'MartinDias 8/7/2012 00:25'!
testByteCannotExtendPointerWithFields

	self shouldnt: [ :builder | 
			builder 
				layoutClass: PointerLayout;
				slots: { #a => Slot } ]
		extendWith: [ :builder | 
			builder layoutClass: ByteLayout ]! !

!SlotClassBuilderTest methodsFor: 'tests-invalid extensions' stamp: 'MartinDias 8/7/2012 00:25'!
testByteCannotExtendWord

	self shouldnt: [ :builder | 
			builder layoutClass: WordLayout ]
		extendWith: [ :builder | 
			builder layoutClass: ByteLayout ]! !

!SlotClassBuilderTest methodsFor: 'tests-announcements' stamp: 'MartinDias 8/20/2012 15:05'!
testClassFormatChangedAnnounced
	| classAdded classModified |
	SystemAnnouncer uniqueInstance weak on: ClassModifiedClassDefinition send: #saveAnnouncementOnce: to: self.
	
	"We create a new class without slots"
	classAdded := self buildClassWithLayout: PointerLayout.
	
	"now we extend it with slots.  The class definition should've changed"
	classModified := self buildClassWithLayout: WeakLayout.
	
	self assert: announcement newClassDefinition equals: classModified.
	self assert: announcement oldClassDefinition format equals: classAdded format.
	self assert: announcement newClassDefinition format equals: classModified format.! !

!SlotClassBuilderTest methodsFor: 'tests-errors' stamp: 'MartinDias 8/6/2012 11:24'!
testClassNameMustBeCapitalized

	self should: [
		self silentlyBuildClassWith: [ :builder | 
			builder name: #aNotCapitalizedClassName  ] ]
		raise: InvalidGlobalNameConflict! !

!SlotClassBuilderTest methodsFor: 'tests-errors' stamp: 'MartinDias 8/6/2012 11:24'!
testClassNameMustBeSymbol

	self should: [
		self silentlyBuildClassWith: [ :builder | 
			builder name: 'NotSymbolClassName'  ] ]
		raise: InvalidGlobalNameConflict! !

!SlotClassBuilderTest methodsFor: 'tests-errors' stamp: 'MartinDias 8/6/2012 11:24'!
testClassNameWithInvalidCharacter

	self should: [
		self silentlyBuildClassWith: [ :builder | 
			builder name: #'Invalid-ClassName'  ] ]
		raise: InvalidGlobalNameConflict.
		
	self flag: 'remove class if present!!'! !

!SlotClassBuilderTest methodsFor: 'tests-errors' stamp: 'MartinDias 8/12/2012 11:53'!
testClassSlotDuplicationConflict

	aClass := self silentlyBuildClassWith: [ :builder | 
		builder classSlots: { #a => Slot } ].

	self should: [ 
		self silentlyBuildClassWith: [ :builder | 
			builder 
				superclass: aClass;
				name: self anotherClassName;
				classSlots: { #a => Slot } ] ]
		raise: SlotDuplicationConflict ! !

!SlotClassBuilderTest methodsFor: 'tests-errors' stamp: 'MartinDias 8/12/2012 11:54'!
testClassSlotWithReservedName

	#(#self #super #thisContext #true #false #nil) do: [:reservedName |
		self should: [ 
			self silentlyBuildClassWith: [ :builder | 
				builder classSlots: { reservedName => Slot } ] ]
			raise: InvalidSlotNameConflict ]! !

!SlotClassBuilderTest methodsFor: 'tests-traits' stamp: 'MartinDias 8/6/2012 18:20'!
testClassWithClassTrait

	aClass := self silentlyBuildClassWith: [ :builder | 
		builder classTraitComposition: TOne ].
	
	self assert: (aClass class canUnderstand: #one).
	self assert: aClass one equals: 1.! !

!SlotClassBuilderTest methodsFor: 'tests-traits' stamp: 'MartinDias 8/1/2012 00:15'!
testClassWithTrait

	aClass := self silentlyBuildClassWith: [ :builder | 
		builder traitComposition: TOne ].
	
	self assert: (aClass canUnderstand: #one).
	self assert: aClass new one equals: 1.! !

!SlotClassBuilderTest methodsFor: 'tests-layouts' stamp: 'GuillermoPolito 7/30/2012 22:19'!
testCompiledMethodLayout
	self assert: (CompiledMethod layout isKindOf: CompiledMethodLayout).! !

!SlotClassBuilderTest methodsFor: 'tests-errors' stamp: 'MartinDias 8/6/2012 11:23'!
testDirectCircularHierarchyError
	"Tests an error is raised when trying to create a heirarchy A<-A"
	
	| classA classB |
	classA := self silentlyBuildClassWith: [ :builder |
			builder 
				superclass: Object;
				name: self aClassName ].

	self should: [ 
		self silentlyBuildClassWith: [ :builder | 
			builder 
				superclass: classA;
				name: self aClassName ] ]
		raise: CircularHierarchyConflict ! !

!SlotClassBuilderTest methodsFor: 'tests-errors' stamp: 'MartinDias 8/6/2012 11:23'!
testIndirectCircularHierarchyError
	"Tests an error is raised when trying to create a heirarchy A<-B<-A"
	
	| classA classB |
	classA := self silentlyBuildClassWith: [ :builder |
			builder 
				superclass: Object;
				name: self aClassName ].

	classB := self silentlyBuildClassWith: [ :builder |
			builder 
				superclass: classA;
				name: self anotherClassName ].

	self should: [ 
		self silentlyBuildClassWith: [ :builder | 
			builder 
				superclass: classB;
				name: self aClassName ] ]
		raise: CircularHierarchyConflict ! !

!SlotClassBuilderTest methodsFor: 'tests-traits' stamp: 'MartinDias 8/6/2012 22:22'!
testModifyClassTraitComposition
	"Tests that when modifing the trait composition on class-side, the old methods are removed from the method dictionary, and the new ones are added."

	self silentlyBuildClassWith: [ :builder | 
		builder classTraitComposition: TOne ].

	aClass := self silentlyBuildClassWith: [ :builder | 
		builder classTraitComposition: TTwo ].
	
	self deny: (aClass class canUnderstand: #one).
	self assert: (aClass class canUnderstand: #two).
! !

!SlotClassBuilderTest methodsFor: 'tests-traits' stamp: 'MartinDias 8/6/2012 22:22'!
testModifyTraitComposition
	"Tests that when modifing the trait composition, the old methods are removed from the method dictionary, and the new ones are added."

	self silentlyBuildClassWith: [ :builder | 
		builder traitComposition: TOne ].

	aClass := self silentlyBuildClassWith: [ :builder | 
		builder traitComposition: TTwo ].
	
	self deny: (aClass canUnderstand: #one).
	self assert: (aClass canUnderstand: #two).
! !

!SlotClassBuilderTest methodsFor: 'tests-announcements' stamp: 'GuillermoPolito 7/30/2012 23:23'!
testNewClassAddedAnnouncedOnlyOnce
	self assertOnlyOneAnnouncementOf: ClassAdded within: [
		"We create a new class without slots"
		self buildClassWithLayout: PointerLayout.
	]! !

!SlotClassBuilderTest methodsFor: 'tests-announcements' stamp: 'MartinDias 8/20/2012 15:03'!
testNewClassAnnounced
	| classAdded |
	SystemAnnouncer uniqueInstance weak on: ClassAdded send: #saveAnnouncement: to: self.
	
	classAdded := self buildClassWithLayout: PointerLayout.
	
	self assert: announcement classAdded equals: classAdded.! !

!SlotClassBuilderTest methodsFor: 'tests-announcements' stamp: 'MartinDias 8/20/2012 15:04'!
testNewClassDefinitionAnnounced
	| classAdded classModified |
	SystemAnnouncer uniqueInstance weak on: ClassModifiedClassDefinition send: #saveAnnouncementOnce: to: self.
	
	"We create a new class without slots"
	classAdded := self buildClassWithLayout: PointerLayout.
	
	"now we extend it with slots.  The class definition should've changed"
	classModified := self buildClassWithLayout: PointerLayout andSlots: { #aSlot => Slot }.
	
	self assert: announcement newClassDefinition equals: classModified.
	self assert: announcement oldClassDefinition allInstVarNames equals: classAdded allInstVarNames.! !

!SlotClassBuilderTest methodsFor: 'tests-announcements' stamp: 'GuillermoPolito 7/30/2012 23:22'!
testNewClassDefinitionAnnouncedOnlyOnce
	
	self assertOnlyOneAnnouncementOf: ClassModifiedClassDefinition within: [
		
		"We create a new class without slots"
		self buildClassWithLayout: PointerLayout.
		
		"now we extend it with slots.  The class definition should've changed"
		self buildClassWithLayout: PointerLayout andSlots: { #aSlot => Slot }.
	]! !

!SlotClassBuilderTest methodsFor: 'tests-layouts' stamp: 'GuillermoPolito 7/30/2012 22:51'!
testNewPointerClass

	aClass := self silentlyBuildClassWithLayout: PointerLayout.
	
	self deny: aClass isCompact.
	self assert: aClass isPointers.
	self assert: aClass isFixed.
	self assert: aClass instVarNames isEmpty.! !

!SlotClassBuilderTest methodsFor: 'tests-layouts' stamp: 'GuillermoPolito 7/30/2012 22:51'!
testNewPointerClassWithVariables

	aClass := self 
		silentlyBuildClassWithLayout: PointerLayout
		andSlots: {
			#id => Slot.
			#name => Slot
		}.
	
	self assert: (aClass instVarNames includes: 'id').
	self assert: (aClass instVarNames includes: 'name').! !

!SlotClassBuilderTest methodsFor: 'tests-layouts' stamp: 'GuillermoPolito 7/30/2012 22:51'!
testNewVariableByteClass

	aClass := self silentlyBuildClassWithLayout: ByteLayout.
	
	self deny: aClass isCompact.
	self deny: aClass isPointers.
	self deny: aClass isFixed.
	self assert: aClass isBytes.
	self assert: aClass isVariable.! !

!SlotClassBuilderTest methodsFor: 'tests-layouts' stamp: 'GuillermoPolito 7/30/2012 22:51'!
testNewVariableWordClass

	aClass := self silentlyBuildClassWithLayout: WordLayout.
	
	self deny: aClass isCompact.
	self deny: aClass isPointers.
	self deny: aClass isFixed.
	self assert: aClass isWords.
	self assert: aClass isVariable.! !

!SlotClassBuilderTest methodsFor: 'tests-layouts' stamp: 'GuillermoPolito 7/30/2012 22:51'!
testNewWeakClass

	aClass := self silentlyBuildClassWithLayout: WeakLayout.
	
	self deny: aClass isCompact.
	self assert: aClass isPointers.
	self deny: aClass isFixed.
	self assert: aClass isWords.
	self assert: aClass isWeak.! !

!SlotClassBuilderTest methodsFor: 'tests-valid extensions' stamp: 'MartinDias 8/7/2012 00:48'!
testPointerCanExtendPointer

	self should: [ :builder | 
			builder layoutClass: PointerLayout ]
		extendWith: [ :builder | 
			builder layoutClass: PointerLayout ]! !

!SlotClassBuilderTest methodsFor: 'tests-valid extensions' stamp: 'MartinDias 8/7/2012 00:36'!
testPointerCanExtendVariable

	self should: [ :builder | 
			builder layoutClass: VariableLayout ]
		extendWith: [ :builder | 
			builder layoutClass: PointerLayout ]! !

!SlotClassBuilderTest methodsFor: 'tests-invalid extensions' stamp: 'MartinDias 8/7/2012 00:25'!
testPointerCannotExtendByte

	self shouldnt: [ :builder | 
			builder layoutClass: ByteLayout ]
		extendWith: [ :builder | 
			builder layoutClass: PointerLayout ]! !

!SlotClassBuilderTest methodsFor: 'tests-invalid extensions' stamp: 'MartinDias 8/7/2012 00:25'!
testPointerCannotExtendWord

	self shouldnt: [ :builder | 
			builder layoutClass: WordLayout ]
		extendWith: [ :builder | 
			builder layoutClass: PointerLayout ]! !

!SlotClassBuilderTest methodsFor: 'tests-class slots' stamp: 'MartinDias 8/6/2012 22:19'!
testRemoveClassSlotAndMigrate

	| classAdded classModified |
	classAdded := 
		self silentlyBuildClassWith: [ :builder | 
			builder classSlots: #(a b) ].

	classAdded instVarNamed: #a put: $A.
	
	classModified := 
		self silentlyBuildClassWith: [ :builder | 
			builder classSlots: #(a) ].
	
	self assert: (classModified instVarNamed: #a) equals: $A.
	self should: [ classModified instVarNamed: #b ] raise: Error
! !

!SlotClassBuilderTest methodsFor: 'tests-traits' stamp: 'MartinDias 8/6/2012 22:21'!
testRemoveClassTrait
	"Tests that when removing a trait from class-side, its methods are removed from the method dictionary."

	self silentlyBuildClassWith: [ :builder | 
		builder classTraitComposition: TOne ].

	aClass := self silentlyBuildClassWith: [ :builder | 
		builder classTraitComposition: {} ].
	
	self deny: (aClass class canUnderstand: #one).
! !

!SlotClassBuilderTest methodsFor: 'tests-shared pools' stamp: 'MartinDias 8/7/2012 02:19'!
testRemoveSharedPool

	self silentlyBuildClassWith: [ :builder | 
		builder sharedPools: 'TestSharedPool' ].

	aClass := self silentlyBuildClassWith: [ :builder | 
		builder sharedPools: '' ].
	
	self assert: aClass sharedPools isEmpty
! !

!SlotClassBuilderTest methodsFor: 'tests-shared variables' stamp: 'MartinDias 8/7/2012 02:37'!
testRemoveSharedVariable

	self silentlyBuildClassWith: [ :builder | 
		builder sharedVariables: 'Var' ].

	aClass := self silentlyBuildClassWith: [ :builder | 
		builder sharedVariables: '' ].
	
	self assert: aClass classVarNames isEmpty! !

!SlotClassBuilderTest methodsFor: 'tests-migrations' stamp: 'MartinDias 7/31/2012 01:07'!
testRemoveSlotAndMigrate
	"We create a class with a slot and create an instance; then we remove the slot and check the instance doesn't hold the value."
	| classAdded classModified |
	classAdded := self silentlyBuildClassWithLayout: PointerLayout andSlots: { #aSlot => Slot }.

	instance := classAdded new.
	"it should have an instance variable"
	instance instVarAt: 1 put: 125.
	
	"now we extend it with slots.  The class definition should've changed"
	classModified := self silentlyBuildClassWithLayout: PointerLayout.
	
	self should: [ instance instVarAt: 1 ] raise: Error.! !

!SlotClassBuilderTest methodsFor: 'tests-traits' stamp: 'MartinDias 8/6/2012 22:22'!
testRemoveTrait
	"Tests that when removing a trait from a class, its methods are removed from the method dictionary."

	self silentlyBuildClassWith: [ :builder | 
		builder traitComposition: TOne ].

	aClass := self silentlyBuildClassWith: [ :builder | 
		builder traitComposition: {} ].
	
	self deny: (aClass canUnderstand: #one).
! !

!SlotClassBuilderTest methodsFor: 'tests-migrations' stamp: 'MartinDias 7/31/2012 01:07'!
testShiftSlotAndMigrate
	| classAdded classModified |
	classAdded := self silentlyBuildClassWithLayout: PointerLayout andSlots: { #a => Slot . #c => Slot }.
	self silentlyCompile: 'a ^a' in: classAdded.
	self silentlyCompile: 'c ^c' in: classAdded.
	
	instance := classAdded new.
	instance instVarNamed: #a put: 1.
	instance instVarNamed: #c put: 3.

	"now we extend it with slots.  The class definition should've changed"
	classModified := self silentlyBuildClassWithLayout: PointerLayout andSlots: { #a => Slot . #b => Slot . #c => Slot }.

	"it should have added an instance variable with nil in the middle"
	self assert: (instance instVarAt: 1) equals: 1.
	self assert: (instance instVarAt: 2) equals: nil.
	self assert: (instance instVarAt: 3) equals: 3.
	
	self assert: (instance instVarNamed: #a) equals: 1.
	self assert: (instance instVarNamed: #b) equals: nil.
	self assert: (instance instVarNamed: #c) equals: 3.
	
	"it should have migrated methods"
	self assert: instance a equals: 1.
	self assert: instance c equals: 3.! !

!SlotClassBuilderTest methodsFor: 'tests-layouts' stamp: 'MartinDias 7/31/2012 01:47'!
testSlotBuilderBuildsClass

	aClass := self silentlyBuildClassWithLayout: PointerLayout.
	
	self assert: (Smalltalk classNamed: self aClassName) == aClass.
	self assert: aClass name = self aClassName.
	self deny: aClass layout isNil.! !

!SlotClassBuilderTest methodsFor: 'tests-errors' stamp: 'MartinDias 8/12/2012 11:55'!
testSlotDuplicationConflict

	aClass := self silentlyBuildClassWith: [ :builder | 
		builder slots: { #a => Slot } ].

	self should: [ 
		self silentlyBuildClassWith: [ :builder | 
			builder 
				superclass: aClass;
				name: self anotherClassName;
				slots: { #a => Slot } ] ]
		raise: SlotDuplicationConflict ! !

!SlotClassBuilderTest methodsFor: 'tests-errors' stamp: 'MartinDias 8/12/2012 11:55'!
testSlotWithReservedName

	#(#self #super #thisContext #true #false #nil) do: [:reservedName |
		self should: [ 
			self silentlyBuildClassWith: [ :builder | 
				builder slots: { reservedName => Slot } ] ]
			raise: InvalidSlotNameConflict ]! !

!SlotClassBuilderTest methodsFor: 'tests-layouts' stamp: 'GuillermoPolito 7/30/2012 22:20'!
testSmallIntegerLayout
	self assert: (SmallInteger layout isKindOf: SmallIntegerLayout).! !

!SlotClassBuilderTest methodsFor: 'tests-class slots' stamp: 'MartinDias 8/6/2012 19:53'!
testSwitchClassSlotAndMigrate

	| classAdded classModified |	
	classAdded := 
		self silentlyBuildClassWith: [ :builder | 
			builder classSlots: #(a b) ].

	"Add methods"	
	self silentlyCompile: 'a ^a' in: classAdded class.
	self silentlyCompile: 'b ^b' in: classAdded class.

	"Put values"
	classAdded instVarNamed: #a put: $A.
	classAdded instVarNamed: #b put: $B.

	"Modify the class"	
	classModified := 
		self silentlyBuildClassWith: [ :builder | 
			builder classSlots: #(b a) ].
	
	"The instance was migrated"
	self assert: (classModified instVarNamed: #a) equals: $A.
	self assert: (classModified instVarNamed: #b) equals: $B.
	
	"The methods were migrated"
	self assert: classModified a equals: $A.
	self assert: classModified b equals: $B.
! !

!SlotClassBuilderTest methodsFor: 'tests-migrations' stamp: 'MartinDias 7/31/2012 01:07'!
testSwitchSlotsAndMigrate
	| classAdded classModified |
	classAdded := self silentlyBuildClassWithLayout: PointerLayout andSlots: { #a => Slot . #b => Slot }.
	self silentlyCompile: 'a ^a' in: classAdded.
	self silentlyCompile: 'b ^b' in: classAdded.

	instance := classAdded new.
	instance instVarNamed: #a put: $A.
	instance instVarNamed: #b put: $B.

	"now we switch the slots. The class definition should've changed"
	classModified := self silentlyBuildClassWithLayout: PointerLayout andSlots: { #b => Slot . #a => Slot }.

	self assert: (instance instVarAt: 1) equals: $B.
	self assert: (instance instVarAt: 2) equals: $A.
	
	self assert: (instance instVarNamed: #a) equals: $A.
	self assert: (instance instVarNamed: #b) equals: $B.

	"it should have migrated methods"
	self assert: instance a equals: $A.
	self assert: instance b equals: $B.! !

!SlotClassBuilderTest methodsFor: 'tests-valid extensions' stamp: 'MartinDias 8/7/2012 00:36'!
testVariableCanExtendPointer

	self should: [ :builder | 
			builder layoutClass: PointerLayout ]
		extendWith: [ :builder | 
			builder layoutClass: VariableLayout ]! !

!SlotClassBuilderTest methodsFor: 'tests-valid extensions' stamp: 'MartinDias 8/7/2012 00:48'!
testVariableCanExtendVariable

	self should: [ :builder | 
			builder layoutClass: VariableLayout ]
		extendWith: [ :builder | 
			builder layoutClass: VariableLayout ]! !

!SlotClassBuilderTest methodsFor: 'tests-invalid extensions' stamp: 'MartinDias 8/7/2012 00:28'!
testVariableCannotExtendByte

	self shouldnt: [ :builder | 
			builder layoutClass: ByteLayout ]
		extendWith: [ :builder | 
			builder layoutClass: VariableLayout ]! !

!SlotClassBuilderTest methodsFor: 'tests-invalid extensions' stamp: 'MartinDias 8/7/2012 00:28'!
testVariableCannotExtendWord

	self shouldnt: [ :builder | 
			builder layoutClass: WordLayout ]
		extendWith: [ :builder | 
			builder layoutClass: VariableLayout ]! !

!SlotClassBuilderTest methodsFor: 'tests-class slots' stamp: 'MartinDias 8/6/2012 18:29'!
testWithClassSlots

	aClass := self silentlyBuildClassWith: [ :builder | 
		builder classSlots: #(a) ].
	
	self assert: aClass class instVarNames equals: #(a).	
	aClass instVarNamed: #a put: $A.
	self assert: (aClass instVarNamed: #a) equals: $A.! !

!SlotClassBuilderTest methodsFor: 'tests-shared pools' stamp: 'MartinDias 8/7/2012 02:16'!
testWithSharedPool

	aClass := self silentlyBuildClassWith: [ :builder | 
		builder sharedPools: 'TestSharedPool' ].
	self silentlyCompile: 'one ^One' in: aClass class.
	
	self assert: (aClass sharedPools includes: TestSharedPool).
	self assert: aClass one = 1.! !

!SlotClassBuilderTest methodsFor: 'tests-shared variables' stamp: 'MartinDias 8/7/2012 02:34'!
testWithSharedVariable

	aClass := self silentlyBuildClassWith: [ :builder | 
		builder sharedVariables: 'Var' ].
	self silentlyCompile: 'var:x  Var:=x' in: aClass class.
	self silentlyCompile: 'var  ^Var' in: aClass class.
	
	aClass var: true.
	
	self assert: aClass classVarNames equals: #(Var).
	self assert: aClass var.! !

!SlotClassBuilderTest methodsFor: 'tests-class slots' stamp: 'MartinDias 8/6/2012 18:29'!
testWithoutClassSlots

	aClass := self silentlyBuildClassWith: [ :builder | 
		builder classSlots: #() ].
	
	self assert: aClass classVarNames isEmpty! !

!SlotClassBuilderTest methodsFor: 'tests-shared pools' stamp: 'MartinDias 8/7/2012 02:10'!
testWithoutSharedPools

	aClass := self silentlyBuildClassWith: [ :builder | 
		builder sharedPools: '' ].
	
	self assert: aClass sharedPools isEmpty! !

!SlotClassBuilderTest methodsFor: 'tests-shared variables' stamp: 'MartinDias 8/7/2012 02:28'!
testWithoutSharedVariables

	aClass := self silentlyBuildClassWith: [ :builder | 
		builder sharedVariables: '' ].
	
	self assert: aClass classVarNames isEmpty! !

!SlotClassBuilderTest methodsFor: 'tests-valid extensions' stamp: 'MartinDias 8/7/2012 00:35'!
testWordCanExtendWord

	self should: [ :builder | 
			builder layoutClass: WordLayout ]
		extendWith: [ :builder | 
			builder layoutClass: WordLayout ]! !

!SlotClassBuilderTest methodsFor: 'tests-invalid extensions' stamp: 'MartinDias 8/7/2012 00:25'!
testWordCannotExtendByte

	self shouldnt: [ :builder | 
			builder layoutClass: ByteLayout ]
		extendWith: [ :builder | 
			builder layoutClass: WordLayout ]! !

!SlotClassBuilderTest methodsFor: 'tests-invalid extensions' stamp: 'MartinDias 8/7/2012 00:25'!
testWordCannotExtendPointerWithFields

	self shouldnt: [ :builder | 
			builder 
				layoutClass: PointerLayout;
				slots: { #a => Slot } ]
		extendWith: [ :builder | 
			builder layoutClass: WordLayout ]! !
TestSharedPool initialize!
